from attrs import Attrs
from rule import Rule

# slovesné skupiny (včetně pravých valencí)

# vlastně tu řeším mediální a finální pozici dohromady, ale potřebuju omezení:
# kterákoli část slovesné skupiny se už mohla vyskytnout před příklonkami
# (či je dokonce jejich součástí)

rules = [
    # TODO: dá se udělat m="[^F]" a zároveň kopírovat modus do VP? nejspíš jo

    # (Kočka se) napila.
    '(VP e g n a m) → (k=5 e g n a m)',

    # (Kočka se) napila mléka.
    Rule('(VP e g n a m) → (k=5 e g n a m) (NP)').insert_token(
        Attrs(phrase='INTER'), before=False, inside=True, after=False),

    # (Kočka se) mléka napila.
    '(VP e g n a m) → (NP) (k=5 e g n a m)',

    # (Kočka se) dychtivě napila.
    '(VP e g n a m) → (ADVP) (VP e g n a m)',

    # (Kočka se) napila dychtivě.
    '(VP e g n a m) → (VP e g n a m) (ADVP)',

    # Chce/musí/lze to odevzdat zítra.
    '(MODAL e g n a m) → (lemma="chtít|muset|lze" e g n a m)',
    '(VP_WITHOUT_MODAL e g n a) → (k=5 e g n a m=F) (ADVP)',  # odevzdat zítra

    # Bude to odevzdávat až za měsíc.
    # Petr bude dělat zkoušku z chemie.
    '(VP e g n a m=B) → (k=5 lemma="být" e g n a m=B) (k=5 m=F) (NP)',
    # TODO: To je strašný, opravdu budu muset udělat nějakej generátor, kterej
    # zaplní tranzitní skelet. Např.:
    # '(VP) → (bude) ten úkol (muset) nejspíš (odevzdat) až příští měsíc'
    # '(VP OBJ_ACC OBJ_DAT) → [Petr] ten úkol (bude) nejspíš (muset) hodně
    # rychle (odevzdat) tomu učiteli'

    #
    # – ten generátor bude muset upravovat obě strany pravidla
    # – přidá třeba OBJ_ACC a OBJ_ACC2/EXTRA (víc jich nečekám):
    #   (VP OBJ_ACC OBJ_ACC2) → (k=5 m="[^F]") (OBJ_ACC)        (OBJ_ACC2)
    #                               učím     Petra (+ANIM)   angličtinu (−ANIM)
    # – životnost bohužel u ženskýho rodu nevím, to je pěkně blbý
    #   musela by se brát z WordNetu, majka to prostě mít nebude

    # Bude to muset odevzdat/odevzdávat až za měsíc.
    '(VP m=F) → (MODAL m=F) (k=5 m=F)',
    '(VP a m=F) → (MODAL m=F) (k=5 a m=F) (ADVP)',

    # '(COPULA e g n a m) → (lemma="být" e g n a m)',

    # (všichni) jsme hladoví
    '(VP e g n a m) → (lemma="být" e g n a m) (ADJP)',

    #
    # (vzácný?) protipříklad proti tomu, že předměty nemůžou být ve stejném c:
    # Učím Petra angličtinu.
    # Petr je mnou učen angličtinu (angličtině zní líp).
    # Angličtina je mnou učena?!
    # – podle VerbaLexu je jeden předmět životný (a fakultativní) a druhý
    #   neživotný (a obligatorní)
    #

    #
    # (VP OBJ_ACC=yes) → (k=5) (NP c=4)
    # (VP OBJ_ACC=yes) → (NP c=4) (k=5)
    #

    # TODO: má smysl zpracovávat spony odděleně od ostatních sloves, protože
    # ostatní nebudou mít „Petr je učitel“ (nominativ)

    # On je pytel blech.
    # '(VP e g n a m) → (lemma="být" e g n a m) (NP)',  # je [něco]

    # Petr půjčil Petrovi knihu.
    # '(S a e g m n) → (NP) (CLITICS) (k=5 a e g m n) (NP) (NP)',
]
