#!/usr/bin/env python3
#!/nlp/projekty/metatrans2/public_html/python3/bin/python3

import sys

from attrs import Attrs
from rule import Rule
from top_down_chart_parser import TopDownChartParser


def test_rule():
    EPSILON = '(X) → ε'
    epsilon = Rule(EPSILON)
    # print(epsilon, epsilon.left, epsilon.right)
    if str(epsilon) != EPSILON:
        raise AssertionError(str(epsilon), EPSILON)


if __name__ == '__main__':
    test_rule()
    # exit(0)

    top_down = TopDownChartParser(argv=sys.argv)

    tokens = [
        Attrs(tag='k2gInSc1', word='krásný'),
        Attrs(tag='k2gInSc1', word='košatý'),
        Attrs(tag='k1', word='strom', g='I', n='S', c='1'),
        # Attrs(word=','),
        Attrs(tag='k7', word='na'),
        Attrs(tag='k3', lemma='který', g='I', n='S'),
        Attrs(tag='k6', word='silně'),
        Attrs(tag='k5', word='foukalo', e='A', a='I', m='A', g='N', n='S'),
        Attrs(tag='k3', word='se'),
        Attrs(tag='k5eNaPmAgInS', word='nevyvrátil'),
    ]
    top_down.parse(tokens)

    tokens = [
        # ?košatý krásný strom (hodnoticí slovo by mělo být před upřesňujícím)
        Attrs(tag='k2', word='krásný', g='I', n='S', c='4'),
        Attrs(tag='k2', word='košatý', g='I', n='S', c='4'),
        Attrs(tag='k1', word='strom', g='I', n='S', c='1'),
    ]
    top_down.parse(tokens, 'NP')

    tokens = (
        'Líbí	líbit	k5eAaImIp3nS',
        'se	sebe	k3xPyFc4',
        'mi	já	k3xPp1nSc3',
        'to	ten	k3xDgNnSc1',
        ',	,	kIx,',
        'co	co	k3yQnSc4',  # cos?
        'jsi	být	k5eAaImIp2nS',
        'napsal	napsat	k5eAaPmAgMnS',
        # '.	.	kIx.',
    )
    top_down.parse_from_vertical(tokens)

    tokens = (
        'On	on	k3xPp3gMnSc1',
        'je	být	k5eAaImIp3nS',
        'pytel	pytel	k1gInSc1',
        'blech	blechy	k1gFnPc2',
    )
    top_down.parse_from_vertical(tokens)


# TODO: automaticky rozpoznat, že jsme na (barevné) konzoli a zapnout pager
def pipepager(text, cmd='less'):
    """Page through text by feeding it to another program."""
    pipe = os.popen(cmd, 'w')
    try:
        pipe.write(text)
        pipe.close()
    except IOError:
        pass # Ignore broken pipes caused by quitting the pager program.
